//----------------------------------------------------------------------//
// FLAC̏														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include "usr_str.h"
#include "usr_file_ex.h"
#include "usr_shell.h"
#include "usr_wic.h"
#include "usr_flac.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
int FLAC_get_BE3(TFileStream *fs)
{
	unsigned int n = 0;
	unsigned char xbuf[4];
	if (fs->Read(xbuf, 3)==3) n = (xbuf[0] << 16) | (xbuf[1] << 8) | xbuf[2];
	return n;
}
//---------------------------------------------------------------------------
int FLAC_get_LE4(TFileStream *fs)
{
	int n = 0;
	unsigned int buf_uint;
	if (fs->Read(&buf_uint, 4)==4) n = buf_uint;
	return n;
}

//---------------------------------------------------------------------------
int FLAC_get_BE4(TFileStream *fs)
{
	int n = 0;
	unsigned char xbuf[4];
	if (fs->Read(xbuf, 4)==4) n = (xbuf[0] << 24) | (xbuf[1] << 16) | (xbuf[2] << 8) | xbuf[3];
	return n;
}

//---------------------------------------------------------------------------
//FLACt@C̏擾
//---------------------------------------------------------------------------
bool FLAC_GetInf(
	UnicodeString fnam,		//t@C
	TStringList *lst,		//ʃXg(=e ̌`Ŋi[)	(default = NULL)
	int *len)				//[o] 								(default = NULL)
{
	bool ret = false;
	try {
		if (!file_exists(fnam)) Abort();

		std::unique_ptr<TFileStream> fs(new TFileStream(fnam, fmOpenRead | fmShareDenyNone));
		BYTE xbuf[4];
		if (fs->Read(xbuf, 4)!=4) Abort();
		if (xbuf[0]!='f' || xbuf[1]!='L' || xbuf[2]!='a' || xbuf[3]!='C') Abort();

		for (;;) {
			if (fs->Read(xbuf, 1)!=1) Abort();
			bool last_blk = ((xbuf[0]&0x80)!=0);

			int dlen  = FLAC_get_BE3(fs.get());
			int nxt_p = fs->Seek(0, soFromCurrent) + dlen;
	
			switch (xbuf[0]) {
			case 0:	//STREAMINFO
				fs->Seek(10, soFromCurrent);
				if (fs->Read(xbuf, 4)==4) {
					unsigned int rate = ((xbuf[0]<<16) | (xbuf[1]<<8) | xbuf[2])>>4;
					unsigned int bit  = ((xbuf[2] & 0x01)<<4) + (xbuf[3]>>4) + 1;
					unsigned int chn  = ((xbuf[2]>>1) & 0x07) + 1;
					UnicodeString tmp;
					if (lst) add_PropLine(_T("`"), tmp.cat_sprintf(_T("%uHz %ubit %uch"), rate, bit, chn), lst);
					unsigned __int64 total = (__int64)(xbuf[2] & 0x04)<<32;
					if (fs->Read(xbuf, 4)!=4) Abort();
					total += (unsigned int)((xbuf[0] << 24) | (xbuf[1] << 16) | (xbuf[2] << 8) | xbuf[3]);
					if (rate>0 && total>0) {
						unsigned int ms = total/rate*1000;
						if (lst) add_PropLine(_T(""), mSecToTStr(ms, false), lst);
						if (len) *len = ms;
					}
				} else Abort();
				break;

			case 4:	//VORBIS_COMMENT
				if (!lst) break;
				dlen = FLAC_get_LE4(fs.get());
				fs->Seek(dlen, soFromCurrent);
				dlen = FLAC_get_LE4(fs.get());
				for (int i=0; i<dlen; i++) {
					int slen = FLAC_get_LE4(fs.get());
					if (slen>0) {
						TBytes Bytes;
						Bytes.Length = slen;
						if (fs->Read(Bytes, slen)!=slen) Abort();
						UnicodeString lbuf = TEncoding::UTF8->GetString(Bytes, 0, Bytes.Length);
						add_PropLine(get_tkn(lbuf, "="), get_tkn_r(lbuf, "="), lst);
					}
				}
				break;
			}

			if (last_blk) break;
			fs->Seek(nxt_p, soFromBeginning);
		}

		ret = true;
	}
	catch (...) {
		if (lst) lst->Clear();
	}
	return ret;
}

//---------------------------------------------------------------------------
//FLACt@C疄ߍ݉摜rbg}bvŎ擾 or t@Cɏo
//---------------------------------------------------------------------------
bool FLAC_GetImage(
	UnicodeString fnam,			//t@C
	Graphics::TBitmap *bmpimg,	//o̓rbg}bv	(default = NULL)
	UnicodeString o_fnam)		//o̓t@C	(default = EmptyStr)
{
	bool ok = false;
	try {
		if (!file_exists(fnam)) Abort();

		std::unique_ptr<TFileStream> fs(new TFileStream(fnam, fmOpenRead | fmShareDenyNone));

		BYTE xbuf[4];
		if (fs->Read(xbuf, 4)!=4) Abort();
		if (xbuf[0]!='f' || xbuf[1]!='L' || xbuf[2]!='a' || xbuf[3]!='C') Abort();

		for (;;) {
			if (fs->Read(xbuf, 1)!=1) Abort();
			bool last_blk = ((xbuf[0]&0x80)!=0);

			int dlen  = FLAC_get_BE3(fs.get());
			int nxt_p = fs->Seek(0, soFromCurrent) + dlen;

			if (xbuf[0]==6) {	//PICTURE
				fs->Seek(4, soFromCurrent);
				//MIME^Cv
				int len = FLAC_get_BE4(fs.get());
				std::unique_ptr<char[]> sbuf(new char[len + 1]);
				if (fs->Read(sbuf.get(), len)!=len) Abort();
				sbuf[len] = 0x00;
				UnicodeString img_typ = sbuf.get();
				//spXLbv
				len = FLAC_get_BE4(fs.get());
				fs->Seek((int)(len + 16), soFromCurrent);

				//C[W
				int size = FLAC_get_BE4(fs.get());
				std::unique_ptr<TMemoryStream> ms(new TMemoryStream());
				if (ms->CopyFrom(fs.get(), size)<size) Abort();
				ms->Seek(0, soFromBeginning);

				if (contained_wd_i(_T("image/jpeg|jpg"), img_typ)) {
					if (bmpimg) {
						if (!WIC_get_from_memory(ms.get(), bmpimg, GUID_ContainerFormatJpeg)) Abort();
						ok = !bmpimg->Empty;
					}
					else if (!o_fnam.IsEmpty()) {
						o_fnam = ChangeFileExt(o_fnam, ".jpg");
						ms->SaveToFile(o_fnam);
						ok = true;
					}
				}
				else if (contained_wd_i(_T("image/png|png"), img_typ)) {
					if (bmpimg) {
						if (!WIC_get_from_memory(ms.get(), bmpimg, GUID_ContainerFormatPng)) Abort();
						ok = !bmpimg->Empty;
					}
					else if (!o_fnam.IsEmpty()) {
						o_fnam = ChangeFileExt(o_fnam, ".png");
						ms->SaveToFile(o_fnam);
						ok = true;
					}
				}
				break;
			}

			if (last_blk) break;

			fs->Seek(nxt_p, soFromBeginning);
		}
	}
	catch (...) {
		ok = false;
	}

	return ok;
}
//---------------------------------------------------------------------------
